/*
 * File:
 *    gefcmn_osa_framework.h
 *
 * Description:
 *    OSA interface for the common API.
 *
 * Copyright:
 *    Copyright 2007 GE Fanuc Intelligent Platforms Embedded Systems, Inc.
 *
 * License:
 *    This file is proprietary to GE Fanuc Intelligent Platforms Embedded Systems, Inc.
 */
/*
 *  $Date: 2007-12-07 10:32:16 -0500 (Fri, 07 Dec 2007) $
 *  $Rev: 4471 $
 */

#ifndef __GEFCMN_OSA_FRAMEWORK_H
#define __GEFCMN_OSA_FRAMEWORK_H

#include "gef/gefcmn_types.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/**
 * Title: SBC Common API OS Abstraction Definitions
 *
 * Description:
 *    This is a common header file for the OS Abstraction.  This file
 *    is not exposed to the user, but must be available for test
 *    applications.
 *
 * Include Files:
 *    gefcmn_types.h 
 *
 * Libraries:
 *    N/A
 *
 * Kernel Modules:
 *    N/A
 */

typedef struct _GEF_OSA_INTF_DATA
{
  GEF_UINT32  command;
  void       *dataToDriver;
  GEF_UINT32  sizeToDriver;
  void       *dataFromDriver;
  GEF_UINT32  sizeFromDriver;
  GEF_UINT32  result;
} GEF_OSA_INTF_DATA;
/*
typedef struct _GEF_OSA_MAP_DATA
{
  GEF_UINT32  map_index;
  GEF_UINT32  result;
} GEF_OSA_MAP_DATA;
*/
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GEFCMN_OSA_FRAMEWORK_H */

